#ifndef _DFFILEDEFAULTVALUE_H_
#define _DFFILEDEFAULTVALUE_H_

// Fehlerzustaende
#include "ErrorState.h"
// Standardtypen
#include "typedef.h"

// Basisklasse einbinden
#include "DFFileIni.h"

/*
 * Standardsektionen und deren Schluessel in Strukturen packen.
 */
struct SMODEM_MC35i {
	INT8 PHONE[24];
	INT8 PIN[20];
	INT8 HOST[60];
	INT8 PORT[6];
	INT8 GPRS[50];
	INT8 USER[21];
	INT8 HTTPSEND[40];
	INT8 PASSWORD[21];
	INT8 ALIVE[6];
	INT8 HTTPTIMEOUT[6];
	INT8 HTTPTYPE[3];
};

class CDFFileDefaultValue : public CDFFileIni
{
public:
	CDFFileDefaultValue();
	virtual ~CDFFileDefaultValue();

	void Reset();
	inline INT32 GetLastErrorState() { return m_errorState; };
	INT32 Load(INT8 *fileName);
	INT32 Save(INT8 *fileName);
	INT32 LoadWin32(INT8 *fileName);
	INT32 SaveWin32(INT8 *fileName);
	INT32 Show();

public:
	SMODEM_MC35i m_mc35i;

protected:
	INT32 m_errorState;
};

#endif