/**
 * @file  DynData.cpp
 * @brief Implementierung der Klasse CDynData.
 */
//////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "DynData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDynData::CDynData()
{
	m_iSize = 0;
	m_ucStatus = 0x00;
}

CDynData::~CDynData()
{
	while (!IsEmpty()) {

		delete GetHead();
		RemoveHead();
	}
}

// Fuegt dem Array einen neuen Datensatz hinzu
int CDynData::AddData(unsigned char *pucBuffer, int iLength)
{

	CDatensatz *pNew = new CDatensatz();
	
	pNew->SetData(pucBuffer, iLength);

	AddTail(pNew);
	m_iSize++;

	return FALSE;
}

// Liefert den Status
unsigned char CDynData::GetState()
{
	return m_ucStatus;
}

// Setzt den Status
int CDynData::SetState(unsigned char ucState)
{
	m_ucStatus = ucState;
	return TRUE;
}

// Liefert den Letzten Datensatz
int CDynData::GetData(unsigned char *pucBuffer, int &iLength)
{
	if(m_iSize == 0){

		iLength = 0;
		
		// keine Daten Vorhanden
		return FALSE;

	} else {

		((CDatensatz*)GetHead())->GetData(pucBuffer);
		iLength = ((CDatensatz*)GetHead())->GetSize();
		
		delete GetHead();
		RemoveHead();

		m_iSize--;
		
		return TRUE; // Daten Vorhanden
	} 

	return FALSE;
}

int CDynData::GetSize()
{
	return m_iSize;
}


