#ifndef _EXTENDED_FLASH_H_
#define _EXTENDED_FLASH_H_

// ########################################################
// Erweiterter Flash

#define EXTENDED_CHECK		0xAAAAAAAE

typedef struct StructAE3Extended {
	ULONG ulCheck;		// muss immer mit 0xAAAAAAAA belegt werden.
	ULONG ulSize;		// groesse der Stuktur sizeof(TAE3Extended)
	ULONG pulIOModule;	// Zeiger auf IOModul - Struktur
	ULONG pulIODigital; // Zeiger auf die 8 TAE3DigitalMDE - Strukturen des IOModul
	ULONG pulMDEDigital; // Zeiger auf die 4 TAE3DigitalMDE - Strukturen fuer intern.
	ULONG pulEKArray;	// Zeiger auf PointerArray der Eingabeketten fuer MDE
	ULONG pulFreeScope;	// Zeiger auf naechsten freien Speicherbereich im ExtendedFlashMem
	ULONG pulEntranceTables; // Tabellen fuer Zutrittskontrolle
	ULONG pulEKArrayEntrance;// Zeiger auf PointerArray der Eingabeketten fuer Zutrittskontrolle
	ULONG pulValueGVx;  // Zeiger auf Struktur mit Standardwerten der GVs
	ULONG pulEntrance2Tables; // Tabellen fuer Zutrittskontrolle
	ULONG pulEKArrayEntrance2;// Zeiger auf PointerArray der Eingabeketten fuer Zutrittskontrolle
	ULONG pulExtended;  // Zeiger auf Struktur fuer Erweiterte Funktionalitaeten
	UCHAR tmp[44];		// auf 100 Byte Strukturgroesse bringen.
	ULONG ulFlags;      // Flags fuer Struktur und Erweiterten Speicher
} TAE3Extended;

// EXTendedFlag fuer Struktur
#define EXTF_EMPTY           0x00000000  // Nicht vorhanden
#define EXTF_NEW             0x00000001  // Struktur angelegt
#define EXTF_DOWNLOAD        0x00000010  // Aus geraet ausgelesene Daten

// Maximalanzahl des Einheitssuffix mit 0 terminie.
#define MAX_UNIT_TXT	5

// Struktur fuer IO-Modul
typedef struct StructAE3IOModule {
	
	// Spannungseingaenge
	UCHAR ucActiveU;                  // Flags welcher Eingang aktiv.
	UCHAR szNameU[8][MAX_S_FELD_TXT]; // Bezeichner der Eingaenge
	float fMinU[8];					  // Minimalwert fuer Berechnung
	float fMaxU[8];					  // Maximalwert fuer Berechnung
	UCHAR szUnitU[8][MAX_UNIT_TXT];	  // Einheit - suffix der Berechnung.
	UCHAR ucOnScreenU;                // Flags ob Ausgabe auf Display erlaubt.

	// Stromeingaenge
	UCHAR ucActiveI;
	UCHAR szNameI[8][MAX_S_FELD_TXT];
	float fMinI[8];
	float fMaxI[8];
	UCHAR szUnitI[8][MAX_UNIT_TXT];
	UCHAR ucOnScreenI;

} TAE3IOModule;


// Struktur fuer Digitale Eingaenge
typedef struct StructDigitalMDE {

	UCHAR ucUseAs;
	UCHAR ucStartLowHigh;
	UCHAR ucStartHighLow;
	unsigned short uiCountDivisor;
	unsigned short uiCycle;
	unsigned short uiTimeOut;

	UCHAR ucTmp[12];

} TAE3DigitalMDE;

// Standardwerte fuer Globale Variable
typedef struct StructValueGVx {

	UCHAR ucFlags;                   // Bitfeld fuer Variablenflag "setzen".
	UCHAR szValue[8][MAX_DATEN_LEN]; // Zu setzender Wert.
} TValueGVx;

// Struktur fuer Erweiterte Funktionalitaeten
typedef struct StructExtended {

	unsigned short doubleInputTime;  // Zeit fuer "Doppelte Eingabe" PZE1/PZE2 Modus in Sekunden
	unsigned short confirmationTime; // Zeit fuer "Besttigungsfelder" in Sekunden
	// Sommer/Winterzeitumschaltung
	UCHAR daylightActive; // Aktivieren der Sommer-/Winterzeitumschaltung (daylight saving)
	UCHAR daylight1Month;  // Monat in dem Umgestellt wird (1 - 12)
	UCHAR daylight1Week;   // Monatswoche in der Umgestellt wird (1 - 5, wobei 5 letzte im Monat bedeutet)
	UCHAR daylight1Day;    // Tag der Umschaltung (1 - 7, wobei 1 = Montag)
	UCHAR daylight1Hour;   // Stunde fuer Umschaltung (0 - 23)
	UCHAR daylight2Month;  // Monat in dem Umgestellt wird (1 - 12)
	UCHAR daylight2Week;   // Monatswoche in der Umgestellt wird (1 - 5, wobei 5 letzte im Monat bedeutet)
	UCHAR daylight2Day;    // Tag der Umschaltung (1 - 7, wobei 1 = Montag)
	UCHAR daylight2Hour;   // Stunde fuer Umschaltung (0 - 23)
	UCHAR tmp[1011]; // Frei fuer Erweiterungen
} TExtended;

#endif

