#include "StdAfx.h"
#include "DFFileDocument.h"
#include "../AESetup/AESetupDoc.h"

CDFFileDocument::CDFFileDocument()
{
}

CDFFileDocument::~CDFFileDocument()
{
}

void CDFFileDocument::Reset()
{
	// Member initialisieren
	m_errorState = ES_NO;

	m_sizeData = 0;
}

INT32 CDFFileDocument::Load(INT8 *fileName)
{
	return TRUE;
}

INT32 CDFFileDocument::Save(INT8 *fileName, CAESetupDoc *doc, UINT8 append)
{
	// Schreiben der Hexdatei
	FILE *fp;
	INT8 data[0x400];

	if ((fp = fopen(fileName, "w")) == (FILE*)0) {
		// Oeffnen der Datei gescheitert
		m_errorState = ES_FILE_OPEN;
		return FALSE;
	}

	// Fehlerobjekt zuruecksetzten
	m_errorState = ES_NO;

	UINT32 numLine = 0;
	UINT8 lastUsebit = 0, sizeRecord = 0;
	UINT16 i, address = 0;
	UINT32 baseAddress = 0;
/*
	// Version setzen
	m_header.version = DFFILEDEVICE_VERSION;

	// Dateiheader schreiben
	for (i=0; i < sizeof(m_header); i += INTELHEX_DATA_COUNT) {

		// Extended Segment Address Record
		if (!MakeTypedDataLine(i, INTELHEX_TYPE_DEVICE_HEADER, &((UINT8*)&m_header)[i],
			(sizeof(m_header) - i) > INTELHEX_DATA_COUNT ? INTELHEX_DATA_COUNT : sizeof(m_header) - i, data)) {

			m_errorState = ES_INTELHEX_MAKE_RECORD;
			break;
		}

		fprintf(fp, "%s\n", data);
		numLine++;
	}

	// Abbruch nach Fehler
	if (m_errorState != ES_NO) {

		fclose(fp);
		return FALSE;
	}
*/	
	// Verschluesselungstabelle schreiben
	for (i=0; i < EEP_SIZE; i += INTELHEX_DATA_COUNT) {

		// Extended Segment Address Record
		if (!MakeTypedDataLine(i, INTELHEX_TYPE_DOCUMENT_EEPROM, &doc->EepMem[i],
			(EEP_SIZE - i) > INTELHEX_DATA_COUNT ? INTELHEX_DATA_COUNT : EEP_SIZE - i, data)) {

			m_errorState = ES_INTELHEX_MAKE_RECORD;
			break;
		}

		fprintf(fp, "%s\n", data);
		numLine++;
	}

	// Abbruch nach Fehler
	if (m_errorState != ES_NO) {

		fclose(fp);
		return FALSE;
	}

	// Verschluesselungstabelle schreiben
	for (i=0; i < doc->m_ulFlashSetupSize; i += INTELHEX_DATA_COUNT) {

		// Extended Segment Address Record
		if (!MakeTypedDataLine(i, INTELHEX_TYPE_DOCUMENT_FLASH, &doc->FlashMem[i],
			((doc->m_ulFlashSetupSize - i) > INTELHEX_DATA_COUNT) ? INTELHEX_DATA_COUNT : UCHAR(doc->m_ulFlashSetupSize - i), data)) {

			m_errorState = ES_INTELHEX_MAKE_RECORD;
			break;
		}

		fprintf(fp, "%s\n", data);
		numLine++;
	}

	// Abbruch nach Fehler
	if (m_errorState != ES_NO) {

		fclose(fp);
		return FALSE;
	}

	// Verschluesselungstabelle schreiben
	for (i=0; i < doc->m_ulFlashSetupSize; i += INTELHEX_DATA_COUNT) {

		// Extended Segment Address Record
		if (!MakeTypedDataLine(i, INTELHEX_TYPE_DOCUMENT_XFLASH, &doc->ExtendedMem[i],
			(sizeof(doc->ExtendedMem) - i) > INTELHEX_DATA_COUNT ? INTELHEX_DATA_COUNT : sizeof(doc->FlashMem) - i, data)) {

			m_errorState = ES_INTELHEX_MAKE_RECORD;
			break;
		}

		fprintf(fp, "%s\n", data);
		numLine++;
	}

	// Abbruch nach Fehler
	if (m_errorState != ES_NO) {

		fclose(fp);
		return FALSE;
	}

	// Verschluesselungstabelle schreiben
	for (i=0; i < CONFIG_SIZE_SU; i += INTELHEX_DATA_COUNT) {

		// Extended Segment Address Record
		if (!MakeTypedDataLine(i, INTELHEX_TYPE_DOCUMENT_CONFIG, &doc->ConfigMem[i],
			(CONFIG_SIZE_SU - i) > INTELHEX_DATA_COUNT ? INTELHEX_DATA_COUNT : CONFIG_SIZE_SU - i, data)) {

			m_errorState = ES_INTELHEX_MAKE_RECORD;
			break;
		}

		fprintf(fp, "%s\n", data);
		numLine++;
	}

	// Abbruch nach Fehler
	if (m_errorState != ES_NO) {

		fclose(fp);
		return FALSE;
	}
/*
	// Schreiben der Anwendungsfirmware
	for (; (baseAddress + address) < ATMEGA128_SIZE_PROGRAM; address++) {

		if (m_controller.GetProgramUsebit(baseAddress + address)) {

			if (!lastUsebit) {

				if (baseAddress) {
					// write Extended Linear Address Record
					UINT16 add = baseAddress >> 4;
					UINT8 tmp = ((UINT8*)&add)[0];
					((UINT8*)&add)[0] = ((UINT8*)&add)[1];
					((UINT8*)&add)[1] = tmp;

					// Extended Segment Address Record
					if (!MakeTypedDataLine(0, INTELHEX_TYPE_ESA, (UINT8*)&add, 2, data)) {
						
						m_errorState = ES_INTELHEX_MAKE_RECORD;
						break;
					}

					fprintf(fp, "%s\n", data);
					numLine++;
				}

				lastUsebit = 1;
			} 

			sizeRecord++;
		} else if (sizeRecord) {

			// Angefangenen Datenrecord schreiben
			if (!MakeDataLine(address - sizeRecord, m_controller.GetMemProgram(baseAddress + address - sizeRecord), sizeRecord, data)) {

				m_errorState = ES_INTELHEX_MAKE_RECORD;
				break;
			}

			fprintf(fp, "%s\n", data);
			numLine++;

			sizeRecord = 0;

			// Da Datenstrom abbriss, soll die Basisadresse neu gesetzt werden
			lastUsebit = 0;
		} 
		
		if ((sizeRecord == INTELHEX_DATA_COUNT) ||
			(sizeRecord && ((baseAddress + address) == (ATMEGA128_SIZE_PROGRAM - 1)))) {
			// Vollen oder Rest Datenrecord schreiben
			if (!MakeDataLine(address - (sizeRecord - 1), m_controller.GetMemProgram(baseAddress + address - (sizeRecord - 1)), sizeRecord, data)) {

				m_errorState = ES_INTELHEX_MAKE_RECORD;
				break;
			}

			fprintf(fp, "%s\n", data);
			numLine++;

			sizeRecord = 0;
		} 
		
		// Adressbereich ueberschreitet 64k Block
		if (address == 0xFFFF) {

			// evntl. verbliebene Daten rausschreiben
			if (sizeRecord) {

				// Rest Datenrecord schreiben
				if (!MakeDataLine(address - (sizeRecord - 1), m_controller.GetMemProgram(baseAddress + address - (sizeRecord - 1)), sizeRecord, data)) {

					m_errorState = ES_INTELHEX_MAKE_RECORD;
					break;
				}

				fprintf(fp, "%s\n", data);
				numLine++;

				sizeRecord = 0;
			}

			// Basisadresse erhoehen
			baseAddress += address + 1;

			// Da Datenstrom abbriss, soll die Basisadresse neu gesetzt werden
			lastUsebit = 0;
		}
	}
	fclose(fp);

	// Abbruch nach Fehler
	if (m_errorState != ES_NO) {

		return FALSE;
	}

	// Anzeigedaten in Datei schreiben
	if (!m_fileDisplay.Save(fileName, TRUE)) {

		m_errorState = ES_FILE_OPEN;
		return FALSE;
	}

	// Geraetetexte
	if (!m_fileDeviceText.Save(fileName, TRUE)) {

		m_errorState = ES_FILE_OPEN;
		return FALSE;
	}

	// Endezeile eintragen
	if ((fp = fopen(fileName, "a")) == (FILE*)0) {
		// Oeffnen der Datei gescheitert
		m_errorState = ES_FILE_OPEN;
		return FALSE;
	}
*/
	if (!MakeEndLine(data)) {
		
		fclose(fp);
		m_errorState = ES_INTELHEX_MAKE_RECORD;
		return FALSE;
	}

	fprintf(fp, "%s\n", data);
	numLine++;

	fclose(fp);

	return TRUE;
}