#include "StdAfx.h"
#include "DataFlash.h"

CDataFlash::CDataFlash()
{
	Reset();
}

CDataFlash::~CDataFlash()
{
}

void CDataFlash::Reset()
{
	// Basisadresse auf 0 setzen
	m_baseAddress = 0;
	// Speicher initialisieren
	memset(m_mem, 0xFF, sizeof(m_mem));
	memset(m_memUse, 0, sizeof(m_memUse));
}

void CDataFlash::SetMemUsebit(UINT32 address)
{
	address -= m_baseAddress;
	m_memUse[address / 32] |= (1 << (address % 32));
}

UINT8 CDataFlash::GetMemUsebit(UINT32 address)
{
	address -= m_baseAddress;
	return (m_memUse[address / 32] & (1 << (address % 32))) ? 1 : 0;
}

UINT32 CDataFlash::GetMemFirstAddress()
{
	UINT32 address, firstAddress =  m_baseAddress;
	for (address=0; address < DATAFLASH_SIZE; address++) {

		if (GetMemUsebit(address + m_baseAddress)) {

			firstAddress = address + m_baseAddress;
			break;
		}
	}

	return firstAddress;
}

UINT32 CDataFlash::GetMemLastAddress()
{
	UINT32 address, lastAddress = m_baseAddress;
	for (address=0; address < DATAFLASH_SIZE; address++) {

		if (GetMemUsebit(address + m_baseAddress)) {

			lastAddress = address + m_baseAddress;
		}
	}

	return lastAddress;
}
